"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("./path");
const storeTracker_1 = require("./storeTracker");
exports.getStateFactory = (_getState) => {
    const getState = (path) => {
        const currentState = _getState();
        if (!path)
            return currentState;
        return path_1.getByPath(currentState, String(path));
    };
    return getState;
};
exports.getState = (path) => {
    const activeStore = storeTracker_1.getActiveStore();
    if (activeStore) {
        return activeStore.getState(path);
    }
    else {
        throw Error('[redux-ergo] cannot call `getState()` without a redux store or a custom `getState()` implementation');
    }
};
